<?php
    $formatted = "";
    $output = array();
    $command = "";
    if (!empty($_POST['grep_pattern'])) {
        $command = "grep -RnIi " . escapeshellarg($_POST['grep_pattern']) . " . | grep -v \".svn\"";
        $result = -1;
        $return_code = -1;
        $result = exec($command, $output, $return_code);
        foreach($output as $line) {
            $formatted .= htmlspecialchars($line) . "\n";
        }
    }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">
<html>
    <head>
        <meta http-equiv="Content-type" content="text/html; charset=utf-8">
        <title>PHP grep</title>
    </head>
    <body id="" onload="">
        <form action="php_grep.php" method="post" accept-charset="utf-8">
            <label for="grep_pattern">Grep for: </label><input type="text" name="grep_pattern" value="" id="grep_pattern">
            <p><input type="submit" value="grep it! &rarr;"></p>
        </form>
<?php if (!empty($command)) { ?>
        Command: <code><?php echo htmlspecialchars($command); ?></code><br>
        Output:
        <pre><?php echo $formatted; ?></pre>
        Last line of result was: <code><?php echo htmlspecialchars($result); ?></code><br>
        Return code is: <code><?php echo $return_code; ?></code><br>
        Number of results: <code><?php echo count($output); ?></code>
<?php } ?>
    </body>
</html>