<?php
include_once("ckb/db/mysql-queries.php");
include_once("connection2.php");
//include_once("invio1.php"); // will be in php area
include_once("ckb/email/PHPMailer/class.phpmailer.php");
include_once("shell_exec.php");
set_time_limit(0);

function sendnewsletter()
{
	$count1 = 0;
	$res1 = mysqlselect1('SELECT count(*) as count FROM transmission_log  WHERE status = 0');
	if ($res1) $count1 = (int)$res1['count'];
	echo ($count1);
	if ($count1 > 0)
	{
		$res1 = null;
		$nextchannel = getchannels();

		if ($nextchannel = 0)
		{
			$res1 = transmitmessages();
			if ($res1[0] > 0)
			{
		//		runtransmission($res1[1]) // res1[1] is the next available slot
			}
		}
	}
	return $count1;
}

function transmitmessages()
{
/********************
Will organise the messages in the transmission log
*********************/
	$res1 = mysqlqueryn('SELECT ref1,count[*] as tosend FROM transmission_log WHERE status = 0 GROUP BY ref1');
	foreach ($res1 as $rec)
	{
		$ret1 = array();
		$log = array();
		$log['sent'] = 0;
		$log = sendmessages ($rec['ref1'], $message, $log);
		if ($rec['tosend'] - $log['sent'] > 0)
		{
			$ret1[0] = $rec['tosend'] - $log['sent'];
			$ret1[1] = $log['next'];
			break;
		}
		return $ret1;
	}
}


function sendmessages ($msg, $message, $log)
{
/********************
LOG WILL CONTAIN LOG INFO AND SCHEDULE INFO AND RECURSION INFO
$tosend, sent,next call, next ,SCHEDULE TYPE(SLEEP/SCHEDULE), RECURSION LIMIT, DELAY)
*********************/
	$log['tries'] ++;
	if ($log['tries'] <= $log['maxtries'])
	{
		$res1 = getchannels();
		$slots = $res1[0];
		if ($slots != 0)
		{
			$sendnow = $log['tosend'] <= $slots? $log['tosend']:$slots;
			setupmessage ($msg, $message);
			for ($i1=1; $i1 <= $sendnow; $i1++)
			{
				$log['sent'] += sendmessage($msg, $message, $log);
			}
			$log['tosend'] = $log['tosend'] - $log['sent'];
			if ($log['tosend'] != 0) $log =sendmessages($msg,$message, $log);
		}
	}
	return $log;
}

function sendmessage($msg,$message)
{
	$contact = mysqlselect1("SELECT * FROM transmission_log where ref1 = '".$msg."' AND status=0") ;
	$ok1=0;
	if ($contact)
	{
		$channel = mysqlselect1("SELECT * FROM channels where status=0");
		$message->From = $channel['code']."@aromegroup.com"; //aromegroup would be a system parameter unless we insert entire address in table
		$message->AddAddress($contact['ref2']);
		$ok1=2;
		if($message->Send())
		{
			$ok1=1;
		}
		$date=time(); // put as now
		$res1 = mysqlupdate('UPDATE transmission_log SET status = '. $ok1.', value = "'. (string)$date .'" WHERE uid = '. $contact['uid']);
		if ($ok1==1)
		{
			$prefix = empty($channel['body'])?'':';';
			$channel['body'] .= $prefix.(string)$date;
			$prms =cleanchannel($channel);
		}
	}
	return $ok1=1?1:0;
}

function getchannels()
/***************************
Will check if channels have slots available and return the number of slots available now and
the time at which there will be a new slot available.
****************************/
{
	$channels = mysqlselectn("SELECT * FROM channels");
	$prms= array();
	$prms[0]=0; // No of slots
	$prms[1]=0; //this is the time for next scheduled run
	foreach ($channels as $chan)
	/********************
	Go through the channels and set up availability. This will clean the channels and ensure slots are available now;
	*********************/
	{
		$now = time();
		$prms[1] = 0;
		$res1=cleanchannel($chan);
		$prms[0] += $res1[0];
		if ($res1[1] != 0)
		{
			if ($prms[1] == 0) $prms[1] = $res1[1];
			else if ($prms[1] > $res1[1]) $prms[1] = $res1[1];
		}
	}
	return $prms;
}

function cleanchannel(&$channel)
{
	$prms = explode(';',$channel['data']);
	$slots = array();
	$i1 = 0;
	if (!empty($channel['body']))
	{
		$slots = explode(';',$channel['body']);
		$i1 = count($slots);
		$pretime = time() - (int)$prms[1];
		while (count($slots) > 0)
		{
			if ((int)$slots[0] <= $pretime) array_shift($slots);
			else break;
		}
	}
	$i2 =count($slots);
	//if ($i2 != $i1) // Maybe we should update any way
	{
		$status = $i2 == (int)$prms[0]?1:0;
		$channel['body'] = $i2==0?'':implode(';',$slots);
		$res1=mysqlupdate('UPDATE channels SET status = '.$status.', body = "'.$channel['body'].'" WHERE uid = '.$channel['uid'] );
	}
	$prms[0]=(int)$prms[0]-$i2; //Slots available
	$prms[1] = count($slots) > 0? $slots[0]:0;
	return $prms;
}

function setmailenvparams (&$mail)
/*******************
These are the generic parameters that will come from generic Settings
********************/
{
	$mail->SMTPDebug = 0;
	$mail->SMTPKeepAlive =true;
	$mail->IsSMTP(); // set mailer to use SMTP
	//$mail->SMTPSecure = 'ssl'; // secure transfer enabled REQUIRED for Gmail
	//$mail->SMTPSecure = 'tls'; // secure transfer enabled REQUIRED for Gmail
	//$mail->Host = 'localhost';
	$mail->Host = 'mail.aromegroup.com';
	$mail->Port = 25;
	//$mail->Port = 465;
	$mail->SMTPAuth = true; // turn on SMTP authentication
	$mail->Username = "newsletter@aromegroup.com"; // Check if this changes for each channel
	$mail->Password = "concept"; // SMTP password
	//APPLICATION VARIABLES
	//$mail->From = "newsletter1@jonata.co.uk"; // or if this changes
	$mail->FromName = "Arome Group Newsletter";
	$mail->AddReplyTo("newsletter@aromegroup.com", "Informazione");
	$mail->WordWrap = 50; // set word wrap to 50 characters
	$mail->IsHTML(true); // set email format to HTML - this is application level
}

function setupmessage ($name,&$message)
/*******************************************************
SET UP MESSAGE
This is done at start.
This assumes that one newsletter is sent at a time
and needs renewing to use PHP MAiler Params and many other thing
************************************************/
{
//This are the message specific parameters
	$msg = mysqlselect1("SELECT  * FROM annunci where nome = '". $name."'");
	if ($msg !== null)
	{
		$oggetto = $msg['nome'];
		$nome =$msg['nome'];
		$tipo =$msg['tipo'];
		$message->Subject = $msg['nome'];
//		$mail->Body = file_get_contents('epromo/mailps2.htm');
		$message->Body = "<body>";
		'<meta http-equiv="content-type" content="text/html;charset=iso-8859-1"><!doctype html public "-//w3c//dtd html 4.0 transitional//en"<html><head><meta http-equiv=content-type content="text/html; charset=iso-8859-1"></head><body>';
		$messaggio='';
		if ($msg['tipo'] == '1')
		{
		   include ("email_tipo1.php");
		}
		if ($msg['tipo'] == '2')
		{
		   include ("email_tipo2.php");
		}
		if ($msg['tipo'] == '3')
		{
		   include ("email_tipo3.php");
		}
		$message->Body .= $messaggio;
		$message->Body .= '</body></html>';
		$message->AltBody = "This is the body in plain text for non-HTML mail clients";
		//APPLICATION VARIABLES
		$message->WordWrap = 50; // set word wrap to 50 characters
		$message->ContentType = 'text/html'; // set email format to HTML (database)
	}
}

function transfercontacts($message)
/*******************************
Procedure to manage the placing of contacts on the transmission queu with a continuous (not scheduled Management)
Basically for Arome
*********************************/
{
	$res1 = mysqlselect1('SELECT count(*) as count  FROM arome_indirizzi WHERE flag = "*"');
	$res1 = mysqlupdate('UPDATE arome_indirizzi a SET flag = "" WHERE flag = "*" AND email IN (SELECT ref2 FROM transmission_log WHERE ref1 = 		"'.$message.'")');
	$res1 = mysqlselect1('SELECT count(*) as count FROM arome_indirizzi WHERE flag = "*"');
	$res1 = mysqlinsert('INSERT INTO transmission_log  (ref1,ref2,status) SELECT "'.$message.'",email,0 FROM arome_indirizzi WHERE flag = "*"');
	$res1 = mysqlupdate('UPDATE arome_indirizzi SET flag = "" WHERE flag = "*"');
	return $res1;
}

function starttransmission()
/*****************************
This will set the process off after a send if the transmission process is already running it will leave conytrol to that.
******************************/
{
	// We will include process registration procedures remember path
	/***************************
	Check that the process is already running. If so  Exit
	This usea the MailManager table that contains all management info & quotas
	It runs rge mailsender program
	****************************/
	startprocess('mailsender');
}

function startprocess($name)
/*****************************
This will set the process off after a send if the transmission process is already running it will leave control to that.
******************************/
{
	$process = new process($name);
	if (!$process->isrunning())
	{
		$process->start();
	}
}

?>