<?php
include_once('ckb/db/mysql-queries.php');
include_once('ckb/email/PHPmailer/class.phpmailer.php');
set_time_limit(0);

function transmitmessages()
{
/********************
Will organise the messages in the transmission log
*********************/
	$ret1 = true; // exit if job finished (0 records to send)
	$res1 = mysqlselect1('SELECT count(*) as tosend FROM mm_transmission_log WHERE status = 0');
	$tosend = $res1['tosend'];
	$res1 = mysqlselectn('SELECT ref1,count(*) as tosend FROM mm_transmission_log WHERE status = 0 GROUP BY ref1');
	$sent = 0;
	$message = new PHPMailer();
	foreach ($res1 as $rec)
	{
		$ret1 = array();
		$log = array();
		$log['sent'] = 0;
		$log['tosend']=$rec['tosend'];
		$log = sendmessages ($rec['ref1'], $message, $log);
		$sent += $log['sent'];
		if ($rec['tosend'] - $log['sent'] > 0)
		{
			break;
		}
	}
	if ($sent < $tosend) $ret1 = false;
	file_put_contents('cron.log', ' Send Mail to send '. $tosend . ' - '. $sent .' = '. ($tosend - $sent). PHP_EOL,FILE_APPEND );
	return $ret1;
}


function sendmessages ($msg, $message, $log)
{
/********************
LOG WILL CONTAIN LOG INFO AND SCHEDULE INFO AND RECURSION INFO
$tosend, sent,next call, next ,SCHEDULE TYPE(SLEEP/SCHEDULE), RECURSION LIMIT, DELAY)
*********************/
	$res1 = getchannels();
	$slots = $res1[0];
	if ($slots != 0)
	{
		$sendnow = $log['tosend'] <= $slots? $log['tosend']:$slots;
		setupmessage ($msg, $message);
		for ($i1=1; $i1 <= $sendnow; $i1++)
		{
			$log['sent'] += sendmessage($msg, $message, $log);
		}
		$log['tosend'] = $log['tosend'] - $log['sent'];
	}
	return $log;
}

function sendmessage($msg,$message,$log)
{
	$contact = mysqlselect1("SELECT * FROM mm_transmission_log where ref1 = '".$msg."' AND status=0") ;
	$ok1=0;
	if ($contact)
	{
		$channel = mysqlselect1("SELECT * FROM mm_channels where status=0");
		$message->From = $channel['code']."@aromegroup.com"; //aromegroup would be a system parameter unless we insert entire address in table
		$message->AddAddress($contact['ref2']);
		$ok1=2;
		if($message->Send())
		file_put_contents('cron.log', $msg.';'.$contact['ref2'].';'. date('Y-m-d H:i:s', time()) . PHP_EOL,FILE_APPEND );
			$ok1=1;
		$date=time(); // put as now
		$res1 = mysqlupdate('UPDATE mm_transmission_log SET status = '. $ok1.', value = "'. (string)$date .'" WHERE uid = '. $contact['uid']);
		if ($ok1==1)
		{
			$prefix = empty($channel['body'])?'':';';
			$channel['body'] .= $prefix.(string)$date;
			$prms =cleanchannel($channel);
		}
	}
	return $ok1=1?1:0;
}


function getnextchannel()
/***************************
Gets time of next channel
****************************/
{
	$channels = mysqlselectn("SELECT * FROM mm_channels");
	$prms= array();
	$prms[0]=0; // No of slots
	$prms[1]=0; //this is the time for next scheduled run
	foreach ($channels as $chan)
	/********************
	Go through the channels and set up availability. This will clean the channels and ensure slots are available now;
	*********************/
	{
		$now = time();
		$data = explode(';',$chan['data']);
		$res1=cleanchannel($chan);
		$prms[0] += $res1[0];
		if ($res1[1] != 0)
		{
			$res1[1] += $data[1];
			if ($prms[1] == 0) $prms[1] = $res1[1];
			else if ($prms[1] > $res1[1]) $prms[1] = $res1[1];
		}
	}
	return $prms;
}


function getchannels()
/***************************
Will check if channels have slots available and return the number of slots available now and
the time at which there will be a new slot available.
****************************/
{
	$channels = mysqlselectn("SELECT * FROM mm_channels");
	$prms= array();
	$prms[0]=0; // No of slots
	$prms[1]=0; //this is the time for next scheduled run
	foreach ($channels as $chan)
	/********************
	Go through the channels and set up availability. This will clean the channels and ensure slots are available now;
	*********************/
	{
		$data = explode(';',$channel['data']);
		$now = time();
		$res1=cleanchannel($chan);
		$prms[0] += $res1[0];

		if ($res1[1] != 0)
		{
			$res1[1] += $data[1]; // This sets actual available time.
			if ($prms[1] == 0) $prms[1] = $res1[1];
			else if ($prms[1] > $res1[1]) $prms[1] = $res1[1];
		}
	}
	return $prms;
}

function cleanchannel(&$channel)
{
	$prms = explode(';',$channel['data']);
	$slots = array();
	$i1 = 0;
	if (!empty($channel['body']))
	{
		$slots = explode(';',$channel['body']);
		$i1 = count($slots);
		$pretime = time() - (int)$prms[1];
		while (count($slots) > 0)
		{
			if ((int)$slots[0] <= $pretime) array_shift($slots);
			else break;
		}
	}
	$i2 =count($slots);
	//if ($i2 != $i1) // Maybe we should update any way
	{
		$status = $i2 == (int)$prms[0]?1:0;
		$channel['body'] = $i2==0?'':implode(';',$slots);
		$res1=mysqlupdate('UPDATE mm_channels SET status = '.$status.', body = "'.$channel['body'].'" WHERE uid = '.$channel['uid'] );
	}
	$prms[0]=(int)$prms[0]-$i2; //Slots available
	$prms[1] = count($slots) > 0? $slots[0]:0;
	return $prms;
}

function setmailenvparams (&$mail)
/*******************
These are the generic parameters that will come from generic Settings
********************/
{
	$mail->SMTPDebug = 0;
	$mail->SMTPKeepAlive =true;
	$mail->IsSMTP(); // set mailer to use SMTP
	//$mail->SMTPSecure = 'ssl'; // secure transfer enabled REQUIRED for Gmail
	//$mail->SMTPSecure = 'tls'; // secure transfer enabled REQUIRED for Gmail
	//$mail->Host = 'localhost';
	$mail->Host = 'mail.aromegroup.com';
	$mail->Port = 25;
	//$mail->Port = 465;
	$mail->SMTPAuth = true; // turn on SMTP authentication
	$mail->Username = "newsletter@aromegroup.com"; // Check if this changes for each channel
	$mail->Password = "concept"; // SMTP password
	//APPLICATION VARIABLES
	//$mail->From = "newsletter1@jonata.co.uk"; // or if this changes
	$mail->FromName = "Arome Group Newsletter";
	$mail->AddReplyTo("newsletter@aromegroup.com", "Informazione");
	$mail->WordWrap = 50; // set word wrap to 50 characters
	$mail->IsHTML(true); // set email format to HTML - this is application level
}

function setupmessage ($name,&$message)
/*******************************************************
SET UP MESSAGE
This is done at start.
This assumes that one newsletter is sent at a time
and needs renewing to use PHP MAiler Params and many other thing
************************************************/
{
//This are the message specific parameters
	$msg = mysqlselect1("SELECT  * FROM annunci where nome = '". $name."'");
	if ($msg !== null)
	{
		$oggetto = $msg['nome'];
		$nome =$msg['nome'];
		$tipo =$msg['tipo'];
		$message->Subject = $msg['nome'];
//		$mail->Body = file_get_contents('epromo/mailps2.htm');
		$message->Body = "<body>";
		'<meta http-equiv="content-type" content="text/html;charset=iso-8859-1"><!doctype html public "-//w3c//dtd html 4.0 transitional//en"<html><head><meta http-equiv=content-type content="text/html; charset=iso-8859-1"></head><body>';
		$messaggio='';
		if ($msg['tipo'] == '1')
		{
		   include ("email_tipo1.php");
		}
		if ($msg['tipo'] == '2')
		{
		   include ("email_tipo2.php");
		}
		if ($msg['tipo'] == '3')
		{
		   include ("email_tipo3.php");
		}
		$message->Body .= $messaggio;
		$message->Body .= '</body></html>';
		$message->AltBody = "This is the body in plain text for non-HTML mail clients";
		//APPLICATION VARIABLES
		$message->WordWrap = 50; // set word wrap to 50 characters
		$message->ContentType = 'text/html'; // set email format to HTML (database)
	}
}

function transfercontacts($message)
/*******************************
Procedure to manage the placing of contacts on the transmission queu with a continuous (not scheduled Management)
Basically for Arome
*********************************/
{
	$res1 = mysqlselect1('SELECT count(*) as count  FROM arome_indirizzi WHERE flag = "*"');
	$res1 = mysqlupdate('UPDATE arome_indirizzi a SET flag = "" WHERE flag = "*" AND email IN (SELECT ref2 FROM mm_transmission_log WHERE ref1 = 		"'.$message.'")');
	$res1 = mysqlselect1('SELECT count(*) as count FROM arome_indirizzi WHERE flag = "*"');
	$res1 = mysqlinsert('INSERT INTO mm_transmission_log  (ref1,ref2,status) SELECT "'.$message.'",email,0 FROM arome_indirizzi WHERE flag = "*"');
	$res1 = mysqlupdate('UPDATE arome_indirizzi SET flag = "" WHERE flag = "*"');
	$res1 = mysqlselect1('SELECT count(*) as count FROM mm_transmission_log WHERE status =0 AND ref1 = "'.$message.'"');

	return $res1['count'];
}

function starttransmission()
/*****************************
This will set the process off after a send if the transmission process is already running it will leave conytrol to that.
******************************/
{
	// We will include process registration procedures remember path
	/***************************
	Check that the process is already running. If so  Exit
	This usea the MailManager table that contains all management info & quotas
	It runs rge mailsender program
	****************************/
	startprocess('SendMail');
}

function startprocess($name)
/*****************************
This will set the process off after a send if the transmission process is already running it will leave conytrol to that.
******************************/
{
	$process = new process($name);
	if (!$process->isrunning())
	{
		$process->start();
	}
}

?>